diff --git a/doc/guides/linux_gsg/quick_start.rst b/doc/guides/linux_gsg/quick_start.rst
index 14c4c7763aed..f46c50d04b65 100644
--- a/doc/guides/linux_gsg/quick_start.rst
+++ b/doc/guides/linux_gsg/quick_start.rst
@@ -20,8 +20,6 @@ The dpdk-setup.sh script, found in the usertools subdirectory, allows the user t
 
 *   Set up permissions for using VFIO as a non-privileged user
 
-*   Run the test and testpmd applications
-
 *   Look at hugepages in the meminfo
 
 *   List hugepages in ``/mnt/huge``
@@ -41,17 +39,11 @@ The user configures the Linux* environment to support the running of DPDK applic
 Hugepages can be set up for NUMA or non-NUMA systems. Any existing hugepages will be removed.
 Network ports may be bound to DPDK kernel module for DPDK application use.
 
-**Step 2: Run an Application**
-
-The user may run the test application once the other steps have been performed.
-The test application allows the user to run a series of functional tests for the DPDK.
-The testpmd application, which supports the receiving and sending of packets, can also be run.
-
-**Step 3: Examining the System**
+**Step 2: Examining the System**
 
 This step provides some tools for examining the status of hugepage mappings.
 
-**Step 4: System Cleanup**
+**Step 3: System Cleanup**
 
 The final step has options for restoring the system to its original state.
 
@@ -96,39 +88,29 @@ Some options in the script prompt the user for further data before proceeding.
 
     ------------------------------------------------------------------------
 
-    Step 2: Run test application for linux environment
-
-    ------------------------------------------------------------------------
-
-    [8] Run test application ($RTE_TARGET/app/test)
-
-    [9] Run testpmd application in interactive mode ($RTE_TARGET/app/testpmd)
-
-    ------------------------------------------------------------------------
-
-    Step 3: Other tools
+    Step 2: Other tools
 
     ------------------------------------------------------------------------
 
-    [10] List hugepage info from /proc/meminfo
+    [8] List hugepage info from /proc/meminfo
 
     ------------------------------------------------------------------------
 
-    Step 4: Uninstall and system cleanup
+    Step 3: Uninstall and system cleanup
 
     ------------------------------------------------------------------------
 
-    [11] Unbind NICs from IGB UIO driver
+    [9] Unbind NICs from IGB UIO driver
 
-    [12] Remove IGB UIO module
+    [10] Remove IGB UIO module
 
-    [13] Remove VFIO module
+    [11] Remove VFIO module
 
-    [14] Remove KNI module
+    [12] Remove KNI module
 
-    [15] Remove hugepage mappings
+    [13] Remove hugepage mappings
 
-    [16] Exit Script
+    [14] Exit Script
 
     Option:
 
@@ -136,7 +118,7 @@ The following selection demonstrates the starting of the DPDK UIO driver.
 
 .. code-block:: console
 
-    Option: 12
+    Option: 10
 
     Unloading any existing DPDK UIO module
     Loading DPDK UIO module
diff --git a/usertools/dpdk-setup.sh b/usertools/dpdk-setup.sh
index bcf0c843678f..759f6c096536 100755
--- a/usertools/dpdk-setup.sh
+++ b/usertools/dpdk-setup.sh
@@ -17,11 +17,6 @@ echo "--------------------------------------------------------------------------
 
 HUGEPGSZ=`cat /proc/meminfo  | grep Hugepagesize | cut -d : -f 2 | tr -d ' '`
 
-#
-# Application EAL parameters for setting memory options (amount/channels/ranks).
-#
-EAL_PARAMS='-n 4'
-
 #
 # Sets QUIT variable so script will finish.
 #
@@ -252,34 +247,6 @@ set_numa_pages()
 	create_mnt_huge
 }
 
-#
-# Run unit test application.
-#
-run_test_app()
-{
-	echo ""
-	echo "  Enter hex bitmask of cores to execute test app on"
-	echo "  Example: to execute app on cores 0 to 7, enter 0xff"
-	echo -n "bitmask: "
-	read Bitmask
-	echo "Launching app"
-	sudo ${RTE_TARGET}/app/test -c $Bitmask $EAL_PARAMS
-}
-
-#
-# Run unit testpmd application.
-#
-run_testpmd_app()
-{
-	echo ""
-	echo "  Enter hex bitmask of cores to execute testpmd app on"
-	echo "  Example: to execute app on cores 0 to 7, enter 0xff"
-	echo -n "bitmask: "
-	read Bitmask
-	echo "Launching app"
-	sudo ${RTE_TARGET}/app/testpmd -c $Bitmask $EAL_PARAMS -- -i
-}
-
 #
 # Print hugepage information.
 #
@@ -381,24 +348,10 @@ step1_func()
 	FUNC[7]="set_vfio_permissions"
 }
 
-#
-# Options for running applications.
-#
-step2_func()
-{
-	TITLE="Run test application for linux environment"
-
-	TEXT[1]="Run test application (\$RTE_TARGET/app/test)"
-	FUNC[1]="run_test_app"
-
-	TEXT[2]="Run testpmd application in interactive mode (\$RTE_TARGET/app/testpmd)"
-	FUNC[2]="run_testpmd_app"
-}
-
 #
 # Other options
 #
-step3_func()
+step2_func()
 {
 	TITLE="Other tools"
 
@@ -410,7 +363,7 @@ step3_func()
 #
 # Options for cleaning up the system
 #
-step4_func()
+step3_func()
 {
 	TITLE="Uninstall and system cleanup"
 
@@ -433,7 +386,6 @@ step4_func()
 STEPS[1]="step1_func"
 STEPS[2]="step2_func"
 STEPS[3]="step3_func"
-STEPS[4]="step4_func"
 
 QUIT=0
 